Bugzilla will be upgraded to version 5.0. The upgrade date is tentatively scheduled for 2 December 2018, pending final testing and feedback.
Bug 608141 - Review Request: atkmm - C++ interface for the ATK library
Review Request: atkmm - C++ interface for the ATK library
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Chen Lei
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 608326 610195
  Show dependency treegraph
 
Reported: 2010-06-25 15:33 EDT by Kalev Lember
Modified: 2010-07-01 14:07 EDT (History)
4 users (show)

See Also:
Fixed In Version: atkmm-2.21.2-1.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-07-01 14:07:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
supercyper1: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Kalev Lember 2010-06-25 15:33:38 EDT
Spec URL: http://kalev.fedorapeople.org/atkmm.spec
SRPM URL: http://kalev.fedorapeople.org/atkmm-2.21.1-1.fc14.src.rpm
Description:
atkmm provides a C++ interface for the ATK library. Highlights
include typesafe callbacks, widgets extensible via inheritance and a
comprehensive set of widget classes that can be freely combined to
quickly create complex user interfaces.
Comment 1 Kalev Lember 2010-06-25 15:43:47 EDT
atkmm used to be part of gtkmm, but it was split out to make it easier to have gtkmm24 and gtkmm30 parallel installable.

This package currently Conflicts: gtkmm24 < 2.21.1 because both atkmm and gtkmm24 contain libraries/headers at the same location. Once atkmm is built for rawhide, gtkmm24 can be updated and new version built against the external atkmm.
Comment 2 Kalev Lember 2010-06-26 14:06:57 EDT
* Sat Jun 26 2010 Kalev Lember <kalev@smartlink.ee> - 2.21.1-2
- added missing Conflicts: gtkmm24-devel to -devel subpackage
- calculate two-digit download directory from three-digit package version

Spec URL: http://kalev.fedorapeople.org/atkmm.spec
SRPM URL: http://kalev.fedorapeople.org/atkmm-2.21.1-2.fc14.src.rpm
Comment 3 Chen Lei 2010-06-27 23:35:02 EDT
The Spec file is well-organized, only Requires:       gtk-doc is controversial.


See https://bugzilla.redhat.com/show_bug.cgi?id=604169


Recently, I noticed mclasen dropped this dependency in new review request, so I suggest you also drop Requires:gtk-doc before FPC's final decision on this issue.
Comment 4 Kalev Lember 2010-06-28 02:04:02 EDT
If you are talking about gdk-pixbuf2, then I think that package is actually doing a wrong thing. Probably just an oversight, not something deliberate.

gdk-pixbuf2 currently has:
%files devel
%{_datadir}/gtk-doc/html/*

... and no dependency on gtk-doc.

What matters for RPM directory handling is that every single directory has to be owned by something. If we put files in %{_datadir}/gtk-doc/html/*, then %{_datadir}/gtk-doc/ and %{_datadir}/gtk-doc/html/ need to be either owned by this package or something that it depends on, otherwise RPM will leave directories behind when it removes this package.

In that FPC thread people were suggesting adding these directories to either gnome-filesystem, filesystem, gtk-doc-filesystem, or making every package co-own these directories. Until any of these *filesystem packages are introduced, we have two options:

1) depend on gtk-doc
2) co-own both directories.

I think lets leave the gtk-doc dep as it is right now and wait for FPC decision. I'll keep an eye on the discussion and will update the package accordingly.
Comment 5 Chen Lei 2010-06-28 02:37:28 EDT
(In reply to comment #4)
> If you are talking about gdk-pixbuf2, then I think that package is actually
> doing a wrong thing. Probably just an oversight, not something deliberate.
> 
> gdk-pixbuf2 currently has:
> %files devel
> %{_datadir}/gtk-doc/html/*
> 
> ... and no dependency on gtk-doc.
> 
> What matters for RPM directory handling is that every single directory has to
> be owned by something. If we put files in %{_datadir}/gtk-doc/html/*, then
> %{_datadir}/gtk-doc/ and %{_datadir}/gtk-doc/html/ need to be either owned by
> this package or something that it depends on, otherwise RPM will leave
> directories behind when it removes this package.
> 
Yep, those minor packaging bugs are very common, I can't see any consistency on treating those directory ownership issue.  Even very core packages also have those issues.

> In that FPC thread people were suggesting adding these directories to either
> gnome-filesystem, filesystem, gtk-doc-filesystem, or making every package
> co-own these directories. Until any of these *filesystem packages are
> introduced, we have two options:
> 
> 1) depend on gtk-doc
> 2) co-own both directories.
> 
> I think lets leave the gtk-doc dep as it is right now and wait for FPC
> decision. I'll keep an eye on the discussion and will update the package
> accordingly.    

The problem is those html files are irrelevant to gtk-doc, they are used by devhelp or firefox. Personally, I think adding irrelevant dependencies is also a packaging bug. So I suggest using 2) co-own both directories before FPC's decision.
Comment 6 Chen Lei 2010-06-28 02:43:42 EDT
Since atkmm-devel depends on atk-devel, I think you can drop Requres: gtk-doc safely, because atk-devel already has html docs in /usr/share/gtk-doc.
Comment 7 Kalev Lember 2010-06-28 02:59:36 EDT
It's not a good idea to rely on atk-devel having Requres: gtk-doc. What if, for example, they move documentation to -doc subpackage and Requres: gtk-doc also moves over there?

I feel it's more correct for atkmm-devel to directly depend on gtk-doc (or any other package providing these directories); it's not safe to rely on atk-devel to require the correct package.

Anyway, perhaps we should take this to FPC mailing list instead. As you pointed out, since atk-devel already has gtk-doc dep, then dropping the dep only in atkmm-devel and leaving it in place for atk-devel will still pull in gtk-doc; this is something that needs to be fixed in every package in the distro.
Comment 8 Kalev Lember 2010-06-30 07:14:51 EDT
* Wed Jun 30 2010 Kalev Lember <kalev@smartlink.ee> - 2.21.2-1
- Update to 2.21.2

Spec URL: http://kalev.fedorapeople.org/atkmm.spec
SRPM URL: http://kalev.fedorapeople.org/atkmm-2.21.2-1.fc14.src.rpm

Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2282869
Comment 9 Kalev Lember 2010-06-30 10:02:34 EDT
Chen, is the /usr/share/gtk-doc/ ownership issue a review blocker or can we go on with the review and fix up the package later when FPC decides which is the correct way to handle this?
Comment 10 Chen Lei 2010-07-01 01:40:11 EDT
(In reply to comment #9)
> Chen, is the /usr/share/gtk-doc/ ownership issue a review blocker or can we go
> on with the review and fix up the package later when FPC decides which is the
> correct way to handle this?    

I don't think it's a blocker, either requires gtk-doc or own /usr/share/gtk-doc are fine, it looks like many packages also don't require gtk-doc and own /usr/share/gtk-doc/. 

This package is approved.

formal review here:
+:ok, =:needs attention, -:needs fixing

MUST Items:
[+] MUST: rpmlint must be run on every package.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}
[+] MUST: The package must meet the Packaging Guidelines. [FIXME?: covers this
list and more]
[+] MUST: The package must be licensed with a Fedora approved license and meet
the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual
license.
[+] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source,
as provided in the spec URL.
<<md5sum checksum>>101918284ef37701b4508652180cf4c4
[+] MUST: The package must successfully compile and build into binary rpms on
at least one supported architecture.
[+] MUST: All build dependencies must be listed in BuildRequires
[+] MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro.
[+] MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun.
[+] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.
[+] MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: Each package must consistently use macros, as described in the macros
section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissible content. This is
described in detail in the code vs. content section of Packaging Guidelines.
[+] MUST: If a package includes something as %doc, it must not affect the
runtime of the application.
[+] MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section.
[+] MUST: Packages must not own files or directories already owned by other
packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.
Comment 11 Kalev Lember 2010-07-01 04:44:03 EDT
Thanks for the review, Chen!

New Package CVS Request
=======================
Package Name: atkmm
Short Description: C++ interface for the ATK library
Owners: kalev rishi hguemar
Branches:
InitialCC:
Comment 12 Jason Tibbitts 2010-07-01 13:33:56 EDT
CVS done (by process-cvs-requests.py).
Comment 13 Kalev Lember 2010-07-01 14:07:55 EDT
Built for rawhide, closing the ticket.

Note You need to log in before you can comment on or make changes to this bug.